diff --git a/gdb/breakpoint.c b/gdb/breakpoint.c
index 0724a72..60f8213 100644
--- a/gdb/breakpoint.c
+++ b/gdb/breakpoint.c
@@ -9774,7 +9774,10 @@ create_breakpoint (struct gdbarch *gdbarch,
 
       b->addr_string = copy_arg;
       if (parse_arg)
-	b->cond_string = NULL;
+	{
+	  b->cond_string = NULL;
+	  b->extra_string = NULL;
+	}
       else
 	{
 	  /* Create a private copy of condition string.  */
@@ -9783,10 +9786,16 @@ create_breakpoint (struct gdbarch *gdbarch,
 	      cond_string = xstrdup (cond_string);
 	      make_cleanup (xfree, cond_string);
 	    }
+	  /* Create a private copy of any extra string.  */
+	  if (extra_string)
+	    {
+	      extra_string = xstrdup (extra_string);
+	      make_cleanup (xfree, extra_string);
+	    }
 	  b->cond_string = cond_string;
+	  b->extra_string = extra_string;
 	  b->thread = thread;
 	}
-      b->extra_string = NULL;
       b->ignore_count = ignore_count;
       b->disposition = tempflag ? disp_del : disp_donttouch;
       b->condition_not_parsed = 1;
diff --git a/gdb/testsuite/gdb.mi/mi-dprintf-pending.c b/gdb/testsuite/gdb.mi/mi-dprintf-pending.c
new file mode 100644
index 0000000..d6d8aac
--- /dev/null
+++ b/gdb/testsuite/gdb.mi/mi-dprintf-pending.c
@@ -0,0 +1,24 @@
+/* This testcase is part of GDB, the GNU debugger.
+
+   Copyright 2015 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+extern void pendfunc ();
+
+int main()
+{
+  pendfunc ();
+  return 0; /* set breakpoint 1 here */
+}
diff --git a/gdb/testsuite/gdb.mi/mi-dprintf-pending.exp b/gdb/testsuite/gdb.mi/mi-dprintf-pending.exp
new file mode 100644
index 0000000..6832f1d
--- /dev/null
+++ b/gdb/testsuite/gdb.mi/mi-dprintf-pending.exp
@@ -0,0 +1,77 @@
+# Copyright 2015 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# This test checks if dprintf prints correctly when it's pending.
+# See PR breakpoints/16465.
+
+load_lib mi-support.exp
+
+if {[skip_shlib_tests]} {
+    return 0
+}
+
+standard_testfile mi-dprintf-pending.c
+
+set libfile1 "mi-dprintf-pendshr"
+set libsrc1  $srcdir/$subdir/$libfile1.c
+set lib_sl1  [standard_output_file $libfile1.sl]
+set lib_opts debug
+set exec_opts [list debug shlib=$lib_sl1 shlib_load]
+
+if [get_compiler_info] {
+    return -1
+}
+
+if { [gdb_compile_shlib $libsrc1 $lib_sl1 $lib_opts] != "" } {
+    untested "Could not compile $libsrc1"
+    return -1
+}
+
+if { [gdb_compile $srcdir/$subdir/$srcfile $binfile executable $exec_opts] != ""} {
+    untested "Could not compile $srcdir/$subdir/$srcfile"
+    return -1
+}
+
+# Start with a fresh gdb.
+gdb_exit
+mi_gdb_start
+mi_gdb_reinitialize_dir $srcdir/$subdir
+mi_gdb_load ${binfile}
+mi_load_shlibs $lib_sl1
+
+set bp_location1 [gdb_get_line_number "set breakpoint 1 here"]
+
+# Set pending dprintf via MI.
+mi_gdb_test "-dprintf-insert -f pendfunc1 \"hello\"" \
+    ".*\\^done,bkpt={number=\"1\",type=\"dprintf\",disp=\"keep\",enabled=\"y\",addr=\"<PENDING>\",pending=\"pendfunc1\",times=\"0\",original-location=\"pendfunc1\"}" \
+    "mi set dprintf"
+
+mi_gdb_test "-break-insert $bp_location1" ".*" "mi insert breakpoint bp_location1"
+
+mi_run_cmd
+
+set msg "mi dprintf"
+gdb_expect {
+    -re ".*~\"hello\"" {
+	pass $msg
+    }
+    -re ".*$mi_gdb_prompt$" {
+	fail $msg
+    }
+    timeout {
+	fail $msg
+    }
+}
+mi_expect_stop ".*" ".*" ".*" ".*" ".*" "" "$msg stop"
diff --git a/gdb/testsuite/gdb.mi/mi-dprintf-pendshr.c b/gdb/testsuite/gdb.mi/mi-dprintf-pendshr.c
new file mode 100644
index 0000000..fe49a8d
--- /dev/null
+++ b/gdb/testsuite/gdb.mi/mi-dprintf-pendshr.c
@@ -0,0 +1,27 @@
+/* This testcase is part of GDB, the GNU debugger.
+
+   Copyright 2015 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+void
+pendfunc1 ()
+{
+}
+
+void
+pendfunc ()
+{
+  pendfunc1();
+}